diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
index 8d2dc435e..22eba8002 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 
@@ -13,12 +14,11 @@ import java.util.Arrays;
 import java.util.List;
 
 public class MessageBoxComponent
-    extends PopupComponent
-{
+    extends PopupComponent {
     private static final String FORMAT_REGEX = "[" + TextFormatting.FORMAT_CHARS + "]";
-    private final Minecraft minecraft;
+    private final @NotNull Minecraft minecraft = Minecraft.getMinecraft();
     private float scrollAmount = 0;
-    private final List<String> lines = new ArrayList<>();
+    private final @NotNull List<@NotNull String> lines = new ArrayList<>();
     private final int height;
 
     private int scrollbarX;
@@ -29,33 +29,31 @@ public class MessageBoxComponent
     private int clickY;
     private float previousScrollAmount = 0.0f;
 
-    public MessageBoxComponent(int width, int height, String text, int chars)
-    {
+    public MessageBoxComponent(final int width, final int height, final @NotNull String text, final int chars) {
         super(width);
 
-        this.minecraft = Minecraft.getMinecraft();
         this.height = height;
 
-        setupText(text, chars);
+        this.setupText(text, chars);
     }
 
-    private void setupText(String text, int limit) {
-        lines.clear();
+    private void setupText(final @NotNull String text, final int limit) {
+        this.lines.clear();
 
-        List<String> completeSplit = new ArrayList<>(); //the processed wrapped text, each entry is one line
-        ArrayList<String> newlineSplit = new ArrayList<>(Arrays.asList(text.split("\\n"))); //text split based only on newlines before processing
+        final @NotNull List<@NotNull String> completeSplit = new ArrayList<>(); //the processed wrapped text, each entry is one line
+        final @NotNull ArrayList<@NotNull String> newlineSplit = new ArrayList<>(Arrays.asList(text.split("\\n"))); //text split based only on newlines before processing
 
-        String lastFormat = "";
+        @NotNull String lastFormat = "";
 
-        for (String s : newlineSplit) {
-            ArrayList<String> words = new ArrayList<>(Arrays.asList(s.split(" ")));
-            ArrayList<String> limitedSizeWords = new ArrayList<>(); //all words here should not be larger than the limit
-            StringBuilder line = new StringBuilder();
+        for (final @NotNull String s : newlineSplit) {
+            final @NotNull ArrayList<@NotNull String> words = new ArrayList<>(Arrays.asList(s.split(" ")));
+            final @NotNull ArrayList<@NotNull String> limitedSizeWords = new ArrayList<>(); //all words here should not be larger than the limit
+            @NotNull StringBuilder line = new StringBuilder();
             line.append(lastFormat);
             //split words larger than the limit into multiple that can fit
-            for (String word : words) {
+            for (final @NotNull String word : words) {
                 if (word.length() > limit) {
-                    ArrayList<String> split = new ArrayList<>();
+                    final @NotNull ArrayList<@NotNull String> split = new ArrayList<>();
                     for (int j = 0; j <= word.length() / limit; j++) {
                         split.add(word.substring(j * limit, Math.min((j + 1) * limit, word.length())));
                     }
@@ -64,12 +62,12 @@ public class MessageBoxComponent
                     limitedSizeWords.add(word);
                 }
             }
-            for (String word : limitedSizeWords) {
-                String currentFormat = "";
+            for (final @NotNull String word : limitedSizeWords) {
+                @NotNull String currentFormat = "";
                 //check for formatting and extract it
                 if (word.contains("§")) {
                     if (word.indexOf('§') < word.length() - 1) {
-                        String format = String.valueOf(word.charAt(word.indexOf('§') + 1));
+                        final @NotNull String format = String.valueOf(word.charAt(word.indexOf('§') + 1));
                         if (format.matches(FORMAT_REGEX)) { //if matches any valid text format
                             currentFormat = "§" + format;
                         }
@@ -85,145 +83,132 @@ public class MessageBoxComponent
                     line.append(lastFormat);
                     line.append(word).append(" ");
                 }
-                if(!currentFormat.isEmpty()) lastFormat = currentFormat; //change last format if a new one was found in this iteration
+                if (!currentFormat.isEmpty())
+                    lastFormat = currentFormat; //change last format if a new one was found in this iteration
             }
             completeSplit.add(line.toString());
         }
 
-        lines.addAll(completeSplit);
+        this.lines.addAll(completeSplit);
     }
 
     @Override
-    public int getHeight()
-    {
-        return height;
+    public int getHeight() {
+        return this.height;
     }
 
-    private void scroll(float amount)
-    {
-        scrollAmount = MathHelper.clamp(scrollAmount + amount, 0.0f, 1.0f);
+    private void scroll(final float amount) {
+        this.scrollAmount = MathHelper.clamp(this.scrollAmount + amount, 0.0f, 1.0f);
     }
 
     @Override
-    public void render(int x, int y, int mouseX, int mouseY)
-    {
-
+    public void render(final int x, final int y, final int mouseX, final int mouseY) {
         // Do scroll
-        if (mouseInRegion(x, y, mouseX, mouseY))
-        {
-            float wheel = Mouse.getDWheel();
+        if (this.mouseInRegion(x, y, mouseX, mouseY)) {
+            final float wheel = Mouse.getDWheel();
             if (wheel != 0.0f)
-                scroll(wheel / -12.0f);
+                this.scroll(wheel / -12.0f);
         }
 
         GL11.glDisable(GL11.GL_TEXTURE_2D);
-        drawBackground(x, y);
-        drawScrollbar(x, y, mouseX, mouseY);
+        this.drawBackground(x, y);
+        this.drawScrollbar(x, y, mouseX, mouseY);
 
-        Scissor.enable(x + 1, y + 1, getWidth() - 2, getHeight() - 2);
+        Scissor.enable(x + 1, y + 1, this.getWidth() - 2, this.getHeight() - 2);
         GL11.glEnable(GL11.GL_TEXTURE_2D);
 
         // Draw lines
-        for (int i = 0; i < lines.size(); i++)
-        {
-            this.minecraft.font.render(Tessellator.instance, lines.get(i),x + 4,(y + 4) + (i * 12) - getScrollPixels()).setShadow().call();
+        for (int i = 0; i < this.lines.size(); i++) {
+            this.minecraft.font.render(Tessellator.instance, this.lines.get(i), x + 4, (y + 4) + (i * 12) - this.getScrollPixels()).setShadow().call();
         }
 
         Scissor.disable();
     }
 
-    private boolean mouseInRegion(int x, int y, int mouseX, int mouseY)
-    {
-        return mouseX >= x && mouseX < x + getWidth() && mouseY >= y && mouseY < y + height;
+    private boolean mouseInRegion(final int x, final int y, final int mouseX, final int mouseY) {
+        return mouseX >= x && mouseX < x + this.getWidth() && mouseY >= y && mouseY < y + this.height;
     }
 
-    private int getScrollPixels()
-    {
-        return (int)(scrollAmount * (getScrollableHeight() - (height - 2)));
+    private int getScrollPixels() {
+        return (int) (this.scrollAmount * (this.getScrollableHeight() - (this.height - 2)));
     }
 
-    private int getScrollableHeight()
-    {
-        return Math.max(20 * lines.size(),height);
+    private int getScrollableHeight() {
+        return Math.max(20 * this.lines.size(), this.height);
     }
 
     @Override
-    public void onClick(int x, int y, int button)
-    {
+    public void onClick(final int x, final int y, final int button) {
         super.onClick(x, y, button);
-        
-        if(button == 0 && x >= scrollbarX && x < scrollbarX + scrollbarWidth && y >= scrollbarY && y < scrollbarY + scrollbarHeight) {
-        	isScrolling = true;
-        	previousScrollAmount = scrollAmount;
-        	clickY = y;
-        	return;
+
+        if (button == 0 && x >= this.scrollbarX && x < this.scrollbarX + this.scrollbarWidth && y >= this.scrollbarY && y < this.scrollbarY + this.scrollbarHeight) {
+            this.isScrolling = true;
+            this.previousScrollAmount = this.scrollAmount;
+            this.clickY = y;
         }
     }
-    
+
     @Override
-    public void mouseMovedOrUp(int x, int y, int button)
-    {
-    	super.mouseMovedOrUp(x, y, button);
-    	if(button == 0) {
-    		isScrolling = false;
-    		previousScrollAmount = 0.0f;
-    		clickY = 0;
-    	}
+    public void mouseMovedOrUp(final int x, final int y, final int button) {
+        super.mouseMovedOrUp(x, y, button);
+        if (button == 0) {
+            this.isScrolling = false;
+            this.previousScrollAmount = 0.0f;
+            this.clickY = 0;
+        }
     }
 
-    private void drawBackground(int x, int y)
-    {
-        Tessellator tessellator = Tessellator.instance;
+    private void drawBackground(final int x, final int y) {
+        final Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque_I(0xA0A0A0);
-        tessellator.addVertex(x, y + height, 0.0D);
-        tessellator.addVertex(x + getWidth(), y + height, 0.0D);
-        tessellator.addVertex(x + getWidth(), y, 0.0D);
+        tessellator.addVertex(x, y + this.height, 0.0D);
+        tessellator.addVertex(x + this.getWidth(), y + this.height, 0.0D);
+        tessellator.addVertex(x + this.getWidth(), y, 0.0D);
         tessellator.addVertex(x, y, 0.0D);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque_I(0x000000);
-        tessellator.addVertex(x + 1, y + height - 1, 0.0D);
-        tessellator.addVertex(x + getWidth() - 1, y + height - 1, 0.0D);
-        tessellator.addVertex(x + getWidth() - 1, y + 1, 0.0D);
+        tessellator.addVertex(x + 1, y + this.height - 1, 0.0D);
+        tessellator.addVertex(x + this.getWidth() - 1, y + this.height - 1, 0.0D);
+        tessellator.addVertex(x + this.getWidth() - 1, y + 1, 0.0D);
         tessellator.addVertex(x + 1, y + 1, 0.0D);
         tessellator.draw();
     }
 
-    private void drawScrollbar(int x, int y, int mouseX, int mouseY)
-    {
-    	int scrollableHeight = getScrollableHeight();
-        int displayRegionHeight = height - 2;
-        float scrollbarScale = (float) displayRegionHeight / scrollableHeight;
-        
-    	scrollbarWidth = 6;
-        scrollbarHeight = (int) (scrollbarScale * displayRegionHeight);
-        
-        int minScrollbarY = 0;
-        int maxScrollbarY = displayRegionHeight - scrollbarHeight;
-        
-        int scrollbarDelta = maxScrollbarY - minScrollbarY;
-        
-        scrollbarY = y + 1 + (int) (scrollAmount * scrollbarDelta);
-        scrollbarX = x + getWidth() - 1 - 6;
-        
-        Tessellator t = Tessellator.instance;
+    private void drawScrollbar(final int x, final int y, final int mouseX, final int mouseY) {
+        final int scrollableHeight = this.getScrollableHeight();
+        final int displayRegionHeight = this.height - 2;
+        final float scrollbarScale = (float) displayRegionHeight / scrollableHeight;
+
+        this.scrollbarWidth = 6;
+        this.scrollbarHeight = (int) (scrollbarScale * displayRegionHeight);
+
+        final int minScrollbarY = 0;
+        final int maxScrollbarY = displayRegionHeight - this.scrollbarHeight;
+
+        final int scrollbarDelta = maxScrollbarY - minScrollbarY;
+
+        this.scrollbarY = y + 1 + (int) (this.scrollAmount * scrollbarDelta);
+        this.scrollbarX = x + this.getWidth() - 1 - 6;
+
+        final @NotNull Tessellator t = Tessellator.instance;
 
         t.startDrawingQuads();
         t.setColorRGBA_I(0x808080, 255);
-        t.drawRectangle(scrollbarX, scrollbarY, 6, scrollbarHeight);
+        t.drawRectangle(this.scrollbarX, this.scrollbarY, 6, this.scrollbarHeight);
         t.setColorRGBA_I(0xc0c0c0, 255);
-        t.drawRectangle(scrollbarX, scrollbarY, 5, scrollbarHeight - 1);
+        t.drawRectangle(this.scrollbarX, this.scrollbarY, 5, this.scrollbarHeight - 1);
         t.draw();
-        
-        if(isScrolling) {
-        	int delta = mouseY - clickY;
-        	float scrolledScreens = delta / (float) scrollbarHeight;
-        	float scrolledPixels = displayRegionHeight * scrolledScreens;
-        	float scrolledAmount = scrolledPixels / (float) (scrollableHeight - displayRegionHeight);
-        	
-        	scrollAmount = MathHelper.clamp(previousScrollAmount + scrolledAmount, 0.0f, 1.0f);
+
+        if (this.isScrolling) {
+            final int delta = mouseY - this.clickY;
+            final float scrolledScreens = delta / (float) this.scrollbarHeight;
+            final float scrolledPixels = displayRegionHeight * scrolledScreens;
+            final float scrolledAmount = scrolledPixels / (float) (scrollableHeight - displayRegionHeight);
+
+            this.scrollAmount = MathHelper.clamp(this.previousScrollAmount + scrolledAmount, 0.0f, 1.0f);
         }
-        
+
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
index 2dd4b7466..bacf4c74e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
@@ -3,7 +3,8 @@ package net.minecraft.client.gui.popup;
 import it.unimi.dsi.fastutil.ints.IntIntPair;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.util.collection.Pair;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
 
@@ -11,51 +12,45 @@ import static net.minecraft.client.gui.popup.PopupScreen.VERTICAL_MARGIN;
 import static net.minecraft.client.gui.popup.PopupScreen.HORIZONTAL_MARGIN;
 import static net.minecraft.client.gui.popup.PopupScreen.COMPONENT_GAP;
 
-public class PopupBuilder
-{
-    private final Screen parent;
+public class PopupBuilder {
+    private final @Nullable Screen parent;
     private final int width;
-    private Integer statusCodeOnEsc = null;
-    private Integer statusCodeOnEnter = null;
-    private Integer statusCodeOnClickOut = null;
-    private final List<PopupComponent> components = new ArrayList<>();
-    private final Map<PopupComponent, String> componentKeyMap = new HashMap<>();
-    private final List<PopupCloseListener> onCloseListeners = new ArrayList<>();
-    private IntIntPair backgroundColor = null;
-
-    public PopupBuilder(Screen parent, int width)
-    {
+    private @Nullable Integer statusCodeOnEsc = null;
+    private @Nullable Integer statusCodeOnEnter = null;
+    private @Nullable Integer statusCodeOnClickOut = null;
+    private final @NotNull List<@NotNull PopupComponent> components = new ArrayList<>();
+    private final @NotNull Map<@NotNull PopupComponent, @NotNull String> componentKeyMap = new HashMap<>();
+    private final @NotNull List<@NotNull PopupCloseListener> onCloseListeners = new ArrayList<>();
+    private @Nullable IntIntPair backgroundColor = null;
+
+    public PopupBuilder(final @Nullable Screen parent, final int width) {
         this.parent = parent;
         this.width = width;
     }
 
-    public PopupScreen build()
-    {
-        PopupScreen popup = new PopupScreen(
-                parent,
-                width,
-                getHeight(),
-                statusCodeOnEsc,
-                statusCodeOnEnter,
-                statusCodeOnClickOut,
-                components,
-                componentKeyMap,
-                onCloseListeners,
-                backgroundColor
+    public PopupScreen build() {
+        final PopupScreen popup = new PopupScreen(
+            this.parent,
+            this.width,
+            this.getHeight(),
+            this.statusCodeOnEsc,
+            this.statusCodeOnEnter,
+            this.statusCodeOnClickOut,
+            this.components,
+            this.componentKeyMap,
+            this.onCloseListeners,
+            this.backgroundColor
         );
-        for (PopupComponent component : components)
-        {
+        for (final @NotNull PopupComponent component : this.components) {
             component.setParent(popup);
         }
         return popup;
     }
 
-    private int getHeight()
-    {
+    private int getHeight() {
         int accY = VERTICAL_MARGIN;
 
-        for (PopupComponent component : components)
-        {
+        for (final @NotNull PopupComponent component : this.components) {
             accY += component.getHeight() + COMPONENT_GAP;
         }
 
@@ -65,120 +60,104 @@ public class PopupBuilder
         return accY;
     }
 
-    public PopupBuilder closeOnEsc(int statusCode)
-    {
+    public @NotNull PopupBuilder closeOnEsc(final int statusCode) {
         this.statusCodeOnEsc = statusCode;
         return this;
     }
 
-    public PopupBuilder closeOnEnter(int statusCode)
-    {
+    public @NotNull PopupBuilder closeOnEnter(final int statusCode) {
         this.statusCodeOnEnter = statusCode;
         return this;
     }
 
-    public PopupBuilder closeOnClickOut(int statusCode)
-    {
+    public @NotNull PopupBuilder closeOnClickOut(final int statusCode) {
         this.statusCodeOnClickOut = statusCode;
         return this;
     }
 
-    public PopupBuilder withLabelLiteral(String text, int color)
-    {
-        PopupComponent component = new LabelComponent(width, text, color);
+    public @NotNull PopupBuilder withLabelLiteral(final @NotNull String text, final int color) {
+        final @NotNull PopupComponent component = new LabelComponent(this.width, text, color);
         this.components.add(component);
         return this;
     }
 
-    public PopupBuilder withLabelLiteral(String text)
-    {
-        return withLabelLiteral(text, 0xFFFFFFFF);
+    public @NotNull PopupBuilder withLabelLiteral(final @NotNull String text) {
+        return this.withLabelLiteral(text, 0xFFFFFFFF);
     }
 
-    public PopupBuilder withLabel(String translationKey, int color)
-    {
-        return withLabelLiteral(I18n.getInstance().translateKey(translationKey), color);
+    public @NotNull PopupBuilder withLabel(final @NotNull String translationKey, final int color) {
+        return this.withLabelLiteral(I18n.getInstance().translateKey(translationKey), color);
     }
 
-    public PopupBuilder withLabel(String translationKey)
-    {
-        return withLabel(translationKey, 0xFFFFFFFF);
+    public @NotNull PopupBuilder withLabel(final @NotNull String translationKey) {
+        return this.withLabel(translationKey, 0xFFFFFFFF);
     }
 
-    public PopupBuilder withTextField(String key, String defaultText)
-    {
-        PopupComponent component = new TextInputComponent(width - (HORIZONTAL_MARGIN * 2), defaultText, "");
+    public @NotNull PopupBuilder withTextField(final @NotNull String key, final @NotNull String defaultText) {
+        final @NotNull PopupComponent component = new TextInputComponent(this.width - (HORIZONTAL_MARGIN * 2), defaultText, "");
         this.components.add(component);
         this.componentKeyMap.put(component, key);
         return this;
     }
 
-    public PopupBuilder withTextField(String key, String defaultText, String placeholderTranslationKey)
-    {
-        PopupComponent component = new TextInputComponent(width - (HORIZONTAL_MARGIN * 2), defaultText, I18n.getInstance().translateKey(placeholderTranslationKey));
+    public @NotNull PopupBuilder withTextField(final @NotNull String key, final @NotNull String defaultText, final @NotNull String placeholderTranslationKey) {
+        final @NotNull PopupComponent component = new TextInputComponent(this.width - (HORIZONTAL_MARGIN * 2), defaultText, I18n.getInstance().translateKey(placeholderTranslationKey));
         this.components.add(component);
         this.componentKeyMap.put(component, key);
         return this;
     }
 
-    public PopupBuilder withButtonGroup(String key, String[] buttonTranslationKeys, int[] buttonStatusCodes)
-    {
-        String[] buttonLabels = new String[buttonTranslationKeys.length];
-        for (int i = 0; i < buttonTranslationKeys.length; i++)
-        {
+    public @NotNull PopupBuilder withButtonGroup(final @NotNull String key, final @NotNull String @NotNull [] buttonTranslationKeys, final int @NotNull [] buttonStatusCodes) {
+        final @NotNull String @NotNull [] buttonLabels = new String[buttonTranslationKeys.length];
+        for (int i = 0; i < buttonTranslationKeys.length; i++) {
             buttonLabels[i] = I18n.getInstance().translateKey(buttonTranslationKeys[i]);
         }
-        boolean[] enabled = new boolean[buttonTranslationKeys.length];
-        Arrays.fill(enabled,true);
-        PopupComponent component = new ButtonGroupComponent(width - (HORIZONTAL_MARGIN * 2), buttonLabels, buttonStatusCodes, enabled);
+        final boolean @NotNull [] enabled = new boolean[buttonTranslationKeys.length];
+        Arrays.fill(enabled, true);
+        final PopupComponent component = new ButtonGroupComponent(this.width - (HORIZONTAL_MARGIN * 2), buttonLabels, buttonStatusCodes, enabled);
         this.components.add(component);
         this.componentKeyMap.put(component, key);
         return this;
     }
 
-    public PopupBuilder withButtonGroup(String key, String[] buttonTranslationKeys, int[] buttonStatusCodes, boolean[] enabled)
-    {
-        String[] buttonLabels = new String[buttonTranslationKeys.length];
-        for (int i = 0; i < buttonTranslationKeys.length; i++)
-        {
+    public PopupBuilder withButtonGroup(final @NotNull String key, final @NotNull String @NotNull [] buttonTranslationKeys, final int @NotNull [] buttonStatusCodes, final boolean @NotNull [] enabled) {
+        final @NotNull String @NotNull [] buttonLabels = new String[buttonTranslationKeys.length];
+        for (int i = 0; i < buttonTranslationKeys.length; i++) {
             buttonLabels[i] = I18n.getInstance().translateKey(buttonTranslationKeys[i]);
         }
-        PopupComponent component = new ButtonGroupComponent(width - (HORIZONTAL_MARGIN * 2), buttonLabels, buttonStatusCodes, enabled);
+        final @NotNull PopupComponent component = new ButtonGroupComponent(this.width - (HORIZONTAL_MARGIN * 2), buttonLabels, buttonStatusCodes, enabled);
         this.components.add(component);
         this.componentKeyMap.put(component, key);
         return this;
     }
 
-    public PopupBuilder withList(String key, int height, String[] buttons, String[] buttonDescs, int selectedItem, boolean closeOnItemSelected)
-    {
-        PopupComponent component = new ListComponent(width - (HORIZONTAL_MARGIN * 2), height, buttons, buttonDescs, selectedItem, closeOnItemSelected);
+    public @NotNull PopupBuilder withList(final @NotNull String key, final int height, final @NotNull String @NotNull [] buttons, final @NotNull String @Nullable [] buttonDescs, final int selectedItem, final boolean closeOnItemSelected) {
+        final @NotNull PopupComponent component = new ListComponent(this.width - (HORIZONTAL_MARGIN * 2), height, buttons, buttonDescs, selectedItem, closeOnItemSelected);
         this.components.add(component);
         this.componentKeyMap.put(component, key);
         return this;
     }
 
-    public PopupBuilder withMessageBox(String key, int height, String text, int chars)
-    {
-        PopupComponent component = new MessageBoxComponent(width - (HORIZONTAL_MARGIN * 2), height, text, chars);
+    public @NotNull PopupBuilder withMessageBox(final @NotNull String key, final int height, final @NotNull String text, final int chars) {
+        final @NotNull PopupComponent component = new MessageBoxComponent(this.width - (HORIZONTAL_MARGIN * 2), height, text, chars);
         this.components.add(component);
         this.componentKeyMap.put(component, key);
         return this;
     }
 
-    public PopupBuilder withButton(String key, String labelTranslationKey, int defaultValue, String... valueTranslationKeys) {
-        PopupComponent component = new ButtonComponent(width - (HORIZONTAL_MARGIN * 2), labelTranslationKey, valueTranslationKeys, defaultValue);
+    public @NotNull PopupBuilder withButton(final @NotNull String key, final @NotNull String labelTranslationKey, final int defaultValue, final @NotNull String @NotNull ... valueTranslationKeys) {
+        final PopupComponent component = new ButtonComponent(this.width - (HORIZONTAL_MARGIN * 2), labelTranslationKey, valueTranslationKeys, defaultValue);
         this.components.add(component);
         this.componentKeyMap.put(component, key);
         return this;
     }
 
-    public PopupBuilder withBackgroundColor(int color, int color2){
-        this.backgroundColor = IntIntPair.of(color,color2);
+    public @NotNull PopupBuilder withBackgroundColor(final int color, final int color2) {
+        this.backgroundColor = IntIntPair.of(color, color2);
         return this;
     }
 
-    public PopupBuilder withOnCloseListener(PopupCloseListener listener)
-    {
+    public @NotNull PopupBuilder withOnCloseListener(final @NotNull PopupCloseListener listener) {
         this.onCloseListeners.add(listener);
         return this;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupCloseListener.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupCloseListener.java
index 6103a514c..0a807bc9e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupCloseListener.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupCloseListener.java
@@ -1,8 +1,10 @@
 package net.minecraft.client.gui.popup;
 
+import org.jetbrains.annotations.NotNull;
+
 import java.util.Map;
 
 public interface PopupCloseListener
 {
-    void onClosed(int statusCode, Map<String, ?> results);
+    void onClosed(int statusCode, @NotNull Map<@NotNull String, ?> results);
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupComponent.java
index 01cf5ccc7..ae9a9caec 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupComponent.java
@@ -1,39 +1,40 @@
 package net.minecraft.client.gui.popup;
 
-public abstract class PopupComponent
-{
-    private PopupScreen parent = null;
+import org.jetbrains.annotations.Nullable;
+
+public abstract class PopupComponent {
+    private @Nullable PopupScreen parent = null;
     private final int width;
 
-    public PopupComponent(int width)
-    {
+    public PopupComponent(final int width) {
         this.width = width;
     }
 
-    public void setParent(PopupScreen parent)
-    {
+    public void setParent(final @Nullable PopupScreen parent) {
         this.parent = parent;
     }
 
-    public PopupScreen getParent()
-    {
-        return parent;
+    public @Nullable PopupScreen getParent() {
+        return this.parent;
     }
 
-    public int getWidth()
-    {
-        return width;
+    public int getWidth() {
+        return this.width;
     }
 
     public abstract int getHeight();
 
-    public abstract void render(int x, int y, int mouseX, int mouseY);
+    public abstract void render(final int x, final int y, final int mouseX, final int mouseY);
+
+    public void onClick(final int x, final int y, final int button) {
+    }
 
-    public void onClick(int x, int y, int button) { }
-    
-    public void mouseMovedOrUp(int x, int y, int button) { }
+    public void mouseMovedOrUp(final int x, final int y, final int button) {
+    }
 
-    public void onKeyDown(int keyCode, char c) { }
+    public void onKeyDown(final int keyCode, final char c) {
+    }
 
-    public void tick() { }
+    public void tick() {
+    }
 }
